---
title: Debugging service workers
slug: Tools/Application/Service_workers
tags:
  - Application
  - DevTools
  - Firefox
  - Guide
  - Service Workers
---
<div>{{ToolsSidebar}}</div>

<p>In this article we will look at debugging <a href="/en-US/docs/Web/API/Service_Worker_API">service workers</a> using the Firefox DevTools <a href="/en-US/docs/Tools/Application">Application Panel</a>.</p>

<p>When you open the Application panel’s <em>Service Workers</em> view on a page that doesn't have a service worker registered, you'll get the following output shown:</p>

<p><img alt="the application panel with a message stating that you need to register a service worker to inspect it here" src="https://mdn.mozillademos.org/files/17310/no-service-worker.jpg" style="border-style: solid; border-width: 1px; height: 667px; width: 900px;"></p>

<p>This gives you some advice on what to do if you don't have a service worker registered, and were perhaps expecting there to be one registered! Let's start by troubleshooting this.</p>

<h2 id="Getting_your_service_worker_to_register">Getting your service worker to register</h2>

<p>Before you can look at your service worker in action in the <em>Applications</em> panel, you need to successfully register it. Registration is done with a block of code along these lines, using the <code><a href="/en-US/docs/Web/API/ServiceWorkerContainer/register">register()</a></code> method:</p>

<pre class="brush: js notranslate">if('serviceWorker' in navigator) {
  navigator.serviceWorker
           .register('sw.js')
           .then(function() { console.log('Service Worker Registered'); });
}</pre>

<p>If you get the path wrong, for example, you'll get an error in the <a href="/en-US/docs/Tools/Web_Console">Web Console</a> giving you a hint as to what's wrong, which depends on what exactly is wrong with the code. If this is not enough to help you figure out the problem, you could also try going to the <a href="/en-US/docs/Tools/Debugger">JavaScript Debugger</a> and stepping through your code to pinpoint exactly where it is going wrong.</p>

<h2 id="Debugging_your_service_worker">Debugging your service worker</h2>

<p>In any case, when the service worker is successfully registered, you'll see information about it displayed in the <em>Application</em> &gt; <em>Service Workers</em> view (along with any other service workers registered on the same domain):</p>

<p><img alt="the application panel showing a registered service worker" src="https://mdn.mozillademos.org/files/17313/sw-registered.jpg" style="border-style: solid; border-width: 1px; height: 667px; width: 900px;"></p>

<p>This gives you a variety of information about your service worker:</p>

<ul>
 <li>The URL that the service worker is registered on.</li>
 <li>That last time the service worker was updated (if the service has not been updated, this is when it was first installed).</li>
 <li>The path to the service worker source file.</li>
 <li>The server worker’s status, which can be one of the following:
  <ul>
   <li><em>Stopped</em>: The service worker is installed, but not currently running. When the service worker is stopped, a <em>Start</em> button is provided to start it running, allowing you to trigger the service worker lifecycle.</li>
   <li><em>Running</em>: The service worker is running.</li>
  </ul>
 </li>
</ul>

<p>There are a couple of other useful controls on this view, too.</p>

<h3 id="Unregister">Unregister</h3>

<p>On the right-hand side of the <em>Service Workers</em> view there is an <em>Unregister</em> button, which when pressed unregisters the service worker. This is very useful because, once registered, the service worker will not necessarily update to the new version immediately, which can make debugging a pain. From <a href="/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers#Updating_your_service_worker">Updating your service worker</a>:</p>

<blockquote>
<p>If your service worker has previously been installed, but then a new version of the worker is available on refresh or page load, the new version is installed in the background, but not yet activated. It is only activated when there are no longer any pages loaded that are still using the old service worker. As soon as there are no more such pages still loaded, the new service worker activates.</p>
</blockquote>

<h3 id="Debug">Debug</h3>

<div class="notecard warning">
<p><strong>Important</strong>: The <em>Debug</em> button is currently enabled only in Firefox Nightly.</p>
</div>

<p>When your service worker is running, a <em>Debug</em> button is available next to the Source information (it is disabled when the service worker is stopped). When pressed, this takes you straight to the <a href="/en-US/docs/Tools/Debugger">JavaScript debugger</a> view of your service worker code, and you can use the full power of the debugger to debug it — stepping through code, etc.</p>

<p><img alt="the firefox JS debugger show the code for a service worker" src="https://mdn.mozillademos.org/files/17311/sw-debugger.jpg" style="border-style: solid; border-width: 1px; height: 667px; width: 900px;"></p>

<h2 id="Testing_a_service_worker_cache">Testing a service worker cache</h2>

<p>If you are using your service worker to store your site assets in Cache Storage (using the <a href="/en-US/docs/Web/API/Cache">Cache API</a>), which is essential for creating offline apps, it can be annoying to test the cache. When you fill up the cache with assets, but then want to alter the behavior slightly, you previously had to manually write code to empty the cache, and then fill it again.</p>

<p>The <a href="/en-US/docs/Tools/Storage_Inspector">Firefox DevTools’ Storage tab</a> has a Cache Storage section that lists all the different Caches you have stored under each different origin.</p>

<p><img alt="the firefox storage inspector showing cache storage items" src="https://mdn.mozillademos.org/files/17314/sw-storage.jpg" style="border-style: solid; border-width: 1px; height: 689px; width: 900px;"></p>

<p>Right/<kbd>Ctrl</kbd> clicking on one of the caches gives you two options:</p>

<ul>
 <li><em>Delete All</em> — delete all caches under this origin.</li>
 <li><em>Delete "name of cache"</em> — delete only the highlighted cache.</li>
</ul>

<p>You can also click on one of the individual items stored in the cache, then Right/<kbd>Ctrl</kbd> click on it to get options for deleting just that item, or every item in the cache.</p>

<p>These options make it much easier to remove a cache if it is required for testing a code update.</p>

<p>It is also worth knowing that if you are testing an app's offline capabilities, you'll be able to see whether requests are being retrieved from a service worker-initiated cache rather than from the network by looking at <a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a>.</p>

<p><img alt="the network monitor, showing that requests that come from a cache are marked with service worker" src="https://mdn.mozillademos.org/files/17309/cache-network.jpg" style="border-style: solid; border-width: 1px; height: 445px; width: 900px;"></p>

<p>Resources retrieved from the cache are indicated with <em>service worker</em> in the <em>Transferred</em> column.</p>

<div class="notecard note">
<p><strong>Note</strong>: There is currently a bug whereby the Network Monitor cannot show network requests from a service worker running in a different process to the application ({{bug(1432311)}}).</p>
</div>

<h2 id="Finding_registered_service_workers_on_other_domains">Finding registered service workers on other domains</h2>

<p>As mentioned above, the <em>Service Worker</em> view of the <em>Application</em> panel shows all the service workers registered on the current domain. If you want to see a list of information concerning all the service workers registered on your browser, you can visit <code><a>about:debugging#/runtime/this-firefox</a></code>. Below the list of installed extensions you'll find a list of all the service workers you have registered.</p>
